%This function performs nearest neighbor density estimation
function Class_Prob = NN_KDE_Classify(x, x_location, net)
       
%location_weight could be tuned per dataset, those exhibiting little 
%translation variance would use a higher value
location_weight = 0.5; 

tiny = 0.00001;
unknown = 0.001;

%ensure unit length
norm_x = sqrt(sum(x .^ 2, 1));
norm_x(norm_x == 0) = 1;
x = bsxfun(@rdivide, x, norm_x);

feat_dist = 2 - 2*(net.W * x); %compute distance

if ~isempty(x_location)
    location_dist = Compute_L2_Distance_Matrix(net.W_Locations, x_location);
else
    location_dist = 0;
end

dist = feat_dist + location_weight*location_dist; 
Prob = 1 ./ (dist + tiny); %probability inversely proportional to distance

Class_Prob = zeros(size(x, 2), net.num_classes);

for c = 1:net.num_classes %find nearest neighbors for each class
    mask = net.W_Class == c;          
    Class_Prob(:, c) = max(Prob(mask, :), [], 1);
end

Class_Prob = bsxfun(@rdivide, Class_Prob,  sum(Class_Prob, 2) + eps('single'));
Class_Prob = Class_Prob + unknown;
Class_Prob = bsxfun(@rdivide, Class_Prob,  sum(Class_Prob, 2));